<?php
// $Id: 50_FTPNONADMIN.php.modify.FTP
// Copyright (c) 2008-2022 Michael Stauber, SOLARSPEED.NET
// Copyright (c) 2008-2022 Team BlueOnyx, BLUEONYX.IT
//
// ui extension to set settings for user webs on Vsite creation

if(defined("FTPNONADMIN_EXTENSION_CREATE_VSITE"))
{
    return 1;
}
define("FTPNONADMIN_EXTENSION_CREATE_VSITE", 1);

include_once("UIExtension.php");

class FTPNONADMINExtension extends UIExtension
{
    public $attributes;

    function display(&$helper, &$container, &$cce_info)
    {
        $factory = $helper->getHtmlComponentFactory("base-ftp");

        $cce = $helper->getCceClient();

        //--- Start: Capabilities handling:
        $CI = get_instance();

        // Only 'serverFTP' and 'manageSite' can modify things on this page.
        // Site admins can view it for informational purposes.
        if ($CI->getAllowed('serverFTP')){
            $access = 'rw';
        }
        elseif ($CI->getAllowed('manageSite')) {
            $access = 'rw';
        }
        else {
            $access = 'r';
        }
        //--- Stop: Capabilities handling:

        $defaults = $cce->get($cce_info["CCE_OID"], "FTPNONADMIN");

        //
        //-- Reseller: Can the reseller that owns this Vsite modify this?
        //
        $Vsite = $cce->get($cce_info['CCE_OID'], '');
        $VsiteOwnerObj = $cce->getObject("User", array("name" => $Vsite['createdUser']));
        if ($VsiteOwnerObj['name'] != "admin") {
            $resellerCaps = $cce->scalar_to_array($VsiteOwnerObj['capabilities']);
            if (!in_array('resellerFTP', $resellerCaps)) {
                $defaults["enabled"] = '0';
                $access = 'r';
            }
        }

        //-- 

        // only add page if not already there
        if (isset($cce_info['CAN_ADD_PAGE']))
        {
            $pageId = 'webScripting';
            if (!in_array('webScripting', $container->getPageIds()))
            {
                $container->addPage("webScripting", $factory->getLabel("webScripting"));
            }
        }
        else
        {
            $pageId = $cce_info['PAGED_BLOCK_DEFAULT_PAGE'];
        }

        $xxx = $factory->getBoolean('ftpnonadmin', $defaults['enabled'], $access);
        $container->addFormField(
            $xxx,
            $factory->getLabel('ftpnonadmin'),
            $pageId
            );
    }

    function handle(&$helper, &$errors, &$cce_info, &$attributes)
    {
        $this->attributes = $attributes;

        $cce = $helper->getCceClient();

        $cce->set($cce_info["CCE_OID"], 'FTPNONADMIN', array('enabled' => $this->attributes['ftpnonadmin']));

        $errors = array_merge($errors, $cce->errors());
    }
}
?>